#include <Stepper.h>

Stepper penStepper(360, 4, 5);
Stepper yDirStepper(360, 2, 3);
Stepper xDirStepper(360, 6, 7);


void setup() {
  penStepper.setSpeed(60);
  yDirStepper.setSpeed(150);
  xDirStepper.setSpeed(150);
  pinMode(LED_BUILTIN, OUTPUT);
  Serial.begin(9600);
}

void loop() {
  while (Serial.available()) {   //wenn Daten empfangen wurden und zum Lesen bereitstehen
    String val = Serial.readStringUntil('\n');
    int semicolonIndex = val.indexOf(';');
    int steps = val.substring (0, semicolonIndex).toInt();
    char direc = val.substring (semicolonIndex + 1, semicolonIndex + 2).toInt();

    if ( direc == 0) { //bewegt den Stift
      penStepper.step(steps);
    }

    if (direc == 1) { //bewegt in x-Richtung
      xDirStepper.step(-steps);
    }

    if (direc == 2) {  //bewegt  in y-Richtung
      yDirStepper.step(steps);
    }
  }
  digitalWrite(LED_BUILTIN, HIGH);   // wenn kein Siganl von processing kommt, blinkt die Lampe
  delay(500);
  digitalWrite(LED_BUILTIN, LOW);
  delay(500);
}
