// Live-Aufnahme der Kamera
// Nutzer*in kann Kamera ausrichten
// durch Drücken der Enter-Taste wird ein Bild gemacht und der Zeichenprozess gestartet
// durch Drücken der Delete-Taste wird das Programm neugestartet

import processing.serial.Serial;
Serial myPort;
import processing.video.*;     // Video-Bibliothek importieren
Capture cam;                   // Deklaration der Kamera
PImage pic;                    // Foto, das abgezeichnet werden soll


int xRob =0;          // x-Koordinaten des Roboters:                  
int yRob =0;          // y-Koordinaten des Roboters:
int penPosition= 0;   // Ausgangsposition des Stiftes
int pause= 700;       // Pause zwischen Motorbewegungen

void setup() {
    // Setup des Ports
    String [] ports = Serial.list();
    String portName = ports[ports.length-1];
    myPort= new Serial(this, portName, 9600);
    println(portName);
    
    // Setup der Kamera
    size(640, 480);                         // Bildgröße = Auflösung der Kamera = i.d.R. 640x480
    String[] cameras = Capture.list();      
    cam = new Capture(this, cameras[0]);
    cam.start();
}

// LIVE-AUFNAHME
void draw() {
    if (cam.available() == true) {
        cam.read();
    }
    image(cam, 0, 0);
}

// ZEICHNUNG ANFERTIGEN
void drawMyPicture(){
  
    // BILD AUFNEHMEN
    saveFrame("0-OriginalBild.png");
    pic = get();                         // Screenshot
    pic.loadPixels();                    // erfoderlich, um Pixel zu lesen und zu bearbeiten 
    clear();
 
    // KANTENERKENNUNG
    pic = edgeDetection(pic);
    image(pic, 0, 0);
 
    // KANTEN ZEICHNEN
    sketchEdges(pic);
    saveFrame("6-Zeichenprozess.png");
    
    // SIGNATUR
    signature();
}

// AUSLÖSER
void keyPressed() {        
    if (key == ENTER) {             // Drücken der Enter-Taste startet den Zeichenprozess
        drawMyPicture();
        noLoop();
    } else if (key == DELETE) {     // Drücken der Delete-Taste startet das Programm neu
        loop();
    }
}