// ZEICHENBEFEHLE AUSLESEN:
  // 1. Bild durchlaufen
  // 2. Wenn Kante gefunden (bei Pixel A):
      // a) Stift an dieser Stelle runter
      // b) alle Pixel B drumherum betrachten, in der Reihenfolge:
      //         8, 1, 2,
      //         7, A, 3,
      //         6, 5, 4,
      // c) Wenn Pixel B auch zur Kante gehört:
              // Stift auch diese Position bewegen
              // zurück zu Schritt 2
         // Wenn keiner der Pixel zur Kante gehört:
              // zurück zu Schritt 1
          
void sketchEdges(PImage img) {
   int penDown = 0;
   int penUp = 1;
   boolean onEdge = false;
   
      // Farblegende der Veranschaulichung:
   // Ein-Pixel-Schritt oder Endpixel einer langen Strecke:
   stroke(0, 0, 0);
   fill(0, 0, 250);   
   ellipse(10, 10, 8, 8);
   text("Ende gerade Strecke", 16, 16); 
   // Pixel auf einer geraden Strecke:
   fill(250, 0,0);
   ellipse(10, 30, 8, 8);
   text("Strich", 16, 36);                  
   // erster Pixel auf der gefundenen Kante:
   fill(0, 250, 0);   
   ellipse(10, 50, 8, 8);
   text("Anfang", 16, 56); 
   
   //SCHRITT 1:
   for (int y=1; y<img.height-2; y++) {                       
       for (int x=1; x<img.width-2; x++) {
           int current = y*img.width+x;
           
           //SCHRITT 2:
           if (red(img.pixels[current]) != 0) {       // Wenn der Pixel (x,y) auf einer Kante liegt
               onEdge = true;
    
               //SCHRITT 2a:
               moveTo(current, penUp);                // bewege den Stift zur gefundenen Kante
               moveTo(current, penDown);              // setze den Stift ab
               
               // Veranschaulichung des Zeichenprozesses auf dem Bildschirm
               // Leider geht das nicht ganz reibungslos. Um das Canvas-Fenster zu aktualisieren, muss es aus dem Bildschirm-
               // bereich gezogen werden und wieder zurück
               stroke(0, 250, 0);
               fill(0, 250, 0);
               ellipse(x,y, 1, 1);
               redraw();
               
               int currentX = x;        // aktuelle x-Koordinate im Bild
               int currentY = y;        // aktuelle y-Koordinate
               
               int oldDirection = -1;   // Bewegungsrichtung des letzten Schritts
               int newDirection = 0;    // Bewegungsrichtung des aktuellen Schritts
               
               while (onEdge) {
                   onEdge = false;
                   
                   //SCHRITT 2b:
                   int neighbors[] = {(currentY-1)*img.width+currentX,    // Pixel oben-mitte
                                      (currentY-1)*img.width+currentX+1,  // Pixel oben-rechts
                                      currentY*img.width+currentX+1,      // Pixel rechts
                                      (currentY+1)*img.width+currentX+1,  // Pixel unten-rechts
                                      (currentY+1)*img.width+currentX,    // Pixel unten-mitte
                                      (currentY+1)*img.width+currentX+1, // Pixel unten-links
                                      currentY*img.width+currentX-1,      // Pixel links
                                      (currentY-1)*img.width+currentX-1}; // Pixel oben-links
                   int i = 0;   // Nummer des Nachbarpixels
                   
                   while (i<8) {
                     
                       //SCHRITT 2c:
                       if (red(img.pixels[neighbors[i]]) != 0) {
                           img.pixels[currentY*img.width+currentX] = color(0,0,0);  // aktuellen Pixel aus der Kante löschen
                           currentX = neighbors[i] % img.width;                     // Koordinaten auf Nachbarpixel umdefinineren
                           currentY = (neighbors[i]-currentX)/img.width;
                           
                           oldDirection = newDirection;
                           newDirection = i;
                           
                           i=8;                // Abbruchbedingung für die innere while-Schleife
                           onEdge = true;      // Abbruchbedingung der äußeren while-Schleife aufheben
              
                           if (oldDirection != newDirection) {
                               moveTo(currentY*pic.width+currentX, penDown);
                               
                               // Veranschaulichung des Zeichenprozesses auf dem Bildschirm:
                               stroke(0, 0, 250);
                               fill(0, 0, 250);
                               ellipse(currentX, currentY, 1, 1); 
                               redraw();
                           } else {
                               // Veranschaulichung des Zeichenprozesses auf dem Bildschirm:
                               stroke(250, 0, 0);
                               fill(250, 0, 0); 
                               ellipse(currentX, currentY, 1, 1);
                               redraw();
                           }
                       }
                       i+=1;
                   }
               }
               img.pixels[currentY*img.width+currentX] = color(0,0,0);  // aktuellen Pixel aus der Kante löschen
               moveTo(currentY*pic.width+currentX, penUp);              // Stift hochnehmen
           }
       }
   }   
}